<?php
/*
  $Id$

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2008 osCommerce

  Released under the GNU General Public License

  First Data Global Gateway e4AIM for OsCommerce
  Based on First Data Gateway API Version 12, PHP 5.1.2
*/

class SoapClientHMAC extends SoapClient {
   function SoapClientHMAC($wsdl, $options = NULL) {
	global $context;
	$context = stream_context_create();
	$options['stream_context'] = $context;
	return parent::SoapClient($wsdl, $options);
   }

   function __doRequest($request, $location, $action, $version, $one_way = NULL) {
	global $context;
     $mode_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_MODE'");
     $trans_mode = tep_db_fetch_array($mode_query);
     $show_mode = implode($trans_mode);
       if ($show_mode == 'Test') {  // Demo server
     $hkey_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_MD5_HASH'");
     $hkey = tep_db_fetch_array($hkey_query);
     $idkey_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_TRANSACTION_KEY'");
     $idkey = tep_db_fetch_array($idkey_query);
       } else {  // Live Server
     $hkey_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GGE4_CC_AIM_MD5_HASH'");
     $hkey = tep_db_fetch_array($hkey_query);
     $idkey_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_KEY'");
     $idkey = tep_db_fetch_array($idkey_query);
       }
     $show_hkey = implode($hkey);
	$hmackey = "$show_hkey"; // HMAC Key
     $show_key = implode($idkey);
	$keyid = "$show_key"; // API Key ID
	$hashtime = date("c");
	$hashstr = "POST\ntext/xml; charset=utf-8\n" . sha1($request) . "\n" . $hashtime . "\n" . parse_url($location,PHP_URL_PATH);
	$authstr = base64_encode(hash_hmac("sha1",$hashstr,$hmackey,TRUE));
	if (version_compare(PHP_VERSION, '5.3.11') == -1) {
		ini_set("user_agent", "PHP-SOAP/" . PHP_VERSION . "\r\nAuthorization: GGE4_API " . $keyid . ":" . $authstr . "\r\nx-gge4-date: " . $hashtime . "\r\nx-gge4-content-sha1: " . sha1($request));
	} else {
		stream_context_set_option($context,array("http" => array("header" => "authorization: GGE4_API " . $keyid . ":" . $authstr . "\r\nx-gge4-date: " . $hashtime . "\r\nx-gge4-content-sha1: " . sha1($request))));
	}
    return parent::__doRequest($request, $location, $action, $version, $one_way);
  }
}

class gge4_cc_aim extends SoapClientHMAC {
  var $code, $title, $description, $enabled;

// class constructor

   function gge4_cc_aim() {
	global $order;

      $this->signature = 'gge4|gge4_cc_aim';
      $this->api_version = '12';

      $this->code = 'gge4_cc_aim';
      $this->title = MODULE_PAYMENT_GGE4_CC_AIM_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_GGE4_CC_AIM_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_GGE4_CC_AIM_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_GGE4_CC_AIM_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_GGE4_CC_AIM_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_GGE4_CC_AIM_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_GGE4_CC_AIM_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();
    }

    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_GGE4_CC_AIM_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_GGE4_CC_AIM_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'icon' => $this->public_icon,
                   'module' => $this->public_title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }

      $confirmation = array('fields' => array(array('title' => MODULE_PAYMENT_GGE4_CC_AIM_CREDIT_CARD_OWNER,
                                                    'field' => tep_draw_input_field('cc_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'])),
                                              array('title' => MODULE_PAYMENT_GGE4_CC_AIM_CREDIT_CARD_NUMBER,
                                                    'field' => tep_draw_input_field('cc_number_nh-dns')),
                                              array('title' => MODULE_PAYMENT_GGE4_CC_AIM_CREDIT_CARD_EXPIRES,
                                                    'field' => tep_draw_pull_down_menu('cc_expires_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('cc_expires_year', $expires_year)),
                                              array('title' => MODULE_PAYMENT_GGE4_CC_AIM_CREDIT_CARD_CVC,
                                                    'field' => tep_draw_input_field('cc_cvc_nh-dns', '', 'size="5" maxlength="4"'))));

      return $confirmation;
    }

    function process_button() {
      return false;
    }

    function before_process() {
      global $HTTP_POST_VARS, $customer_id, $order, $sendto, $currency;

	  // Calculate the next expected order id
       $next_inv = '';
       $inv_id = tep_db_query("select orders_id from " . TABLE_ORDERS . " order by orders_id DESC limit 1");
       $last_inv = tep_db_fetch_array($inv_id);
       $next_inv = $last_inv['orders_id']+1;

       if (MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_MODE == 'Test') {
         $exact_id = substr(MODULE_PAYMENT_GGE4_CC_AIM_DEMO_LOGIN_ID, 0, 20);           //Payment Demo Gateway
         $password = substr(MODULE_PAYMENT_GGE4_CC_AIM_DEMO_PASSWORD, 0, 32);          //Gateway Demo Password
       } else {
         $exact_id = substr(MODULE_PAYMENT_GGE4_CC_AIM_LOGIN_ID, 0, 20);           //Payment Live Gateway
         $password = substr(MODULE_PAYMENT_GGE4_CC_AIM_PASSWORD, 0, 32);          //Gateway Live Password
       }

    $trxnProperties = array('ExactID' => $exact_id,       // Gateway ID
                            'Password' => $password,      // Gateway Psswd
                            'Transaction_Type' => '00',   // Transaction Type - Purchase
                            'VerificationStr1' => substr($order->billing['street_address'], 0, 60) . '|' . substr($order->billing['postcode'], 0, 20) . '|' . substr($order->billing['city'], 0, 40) . '|' . substr($order->billing['state'], 0, 40) . '|' . substr($order->billing['country']['title'], 0, 60),
                            'Customer_Ref' => substr($customer_id, 0, 20),
                            'Reference_No' => $next_inv,
                            'Client_IP' => tep_get_ip_address(),
                            'Client_Email' => substr($order->customer['email_address'], 0, 255),
                            'DollarAmount' => substr($this->format_raw($order->info['total']), 0, 15),
                            'Currency' => substr($currency, 0, 3),
                            'CardHoldersName' => substr($HTTP_POST_VARS['cc_owner'], 0, 30),
                            'Card_Number' => substr($HTTP_POST_VARS['cc_number_nh-dns'], 0, 22),
                            'Expiry_Date' => $HTTP_POST_VARS['cc_expires_month'] . $HTTP_POST_VARS['cc_expires_year'],
                            'VerificationStr2' => substr($HTTP_POST_VARS['cc_cvc_nh-dns'], 0, 4),
                            'CVD_Presence_Ind' => '1',
 
                            // Level 2 fields 
                            'ZipCode' => substr($order->billing['postcode'], 0, 20));
    if (MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_MODE == 'Test') {  // Demo server
      $client = new SoapClientHMAC("https://api.demo.globalgatewaye4.firstdata.com/transaction/v12/wsdl");
    } else { // Live Server
      $client = new SoapClientHMAC("https://api.globalgatewaye4.firstdata.com/transaction/v12/wsdl");
    }
    $trxnResult = $client->SendAndCommit($trxnProperties);

    if (($trxnResult->Bank_Resp_Code == '100') && ($trxnResult->EXact_Resp_Code == '00')) {
      $error = false;
    } else {
      $error = ($trxnResult->EXact_Message);
    }

    if ($trxnResult->EXact_Resp_Code == '08') {
      $error_sel = '08';
    } else if ($trxnResult->EXact_Resp_Code == '22') {
      $error_sel = '22';
    } else if ($trxnResult->EXact_Resp_Code == '25') {
      $error_sel = '25';
    } else if ($trxnResult->EXact_Resp_Code == '27') {
      $error_sel = '27';
    } else {
      $error_sel = 'general';
    }

        switch ($error_sel) {
          case '08':
            $show_error = 'invalid_cvv';
            break;

          case '22':
            $show_error = 'invalid_cc';
            break;

          case '25':
            $show_error = 'invalid_expiry';
            break;

          case '27':
            $show_error = 'invalid_cholder';
            break;

          default:
            $show_error = 'general';
            break;
        }

      if ($error !== false) {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error=' . $this->code . '&error=' . $show_error, 'SSL'));
      }

    // kill object
    unset($client);
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_GENERAL;

      switch ($HTTP_GET_VARS['error']) {
        case 'general':
          $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_GENERAL;
          break;

        case 'invalid_expiry':
          $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_INVALID_EXP_DATE;
          break;

        case 'invalid_cc':
          $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_INVALID_CC;
          break;

        case 'invalid_cholder':
          $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_INVALID_CHOLDER;
          break;

        case 'invalid_cvv':
          $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_CVC;
          break;

        default:
          $error_message = MODULE_PAYMENT_GGE4_CC_AIM_ERROR_GENERAL;
          break;
      }

      $error = array('title' => MODULE_PAYMENT_GGE4_CC_AIM_ERROR_TITLE,
                     'error' => $error_message);

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GGE4_CC_AIM_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable Payeezy Credit Card AIM', 'MODULE_PAYMENT_GGE4_CC_AIM_STATUS', 'False', 'Do you want to accept Payeezy Credit Card AIM payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_MODE', 'Live', 'Perform transactions on the live or demo server. The demo settings should only be used by developers with First Data demo test accounts.', '6', '0', 'tep_cfg_select_option(array(\'Live\', \'Test\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Gateway ID', 'MODULE_PAYMENT_GGE4_CC_AIM_LOGIN_ID', '', 'The Gateway ID used for the Payeezy E-Commerce Transactions', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Gateway Password', 'MODULE_PAYMENT_GGE4_CC_AIM_PASSWORD', '', 'The Gateway password to authorize payments', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Transaction Key', 'MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_KEY', '', 'The Gateway Transaction Key to authorize payments', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('HMAC Key', 'MODULE_PAYMENT_GGE4_CC_AIM_MD5_HASH', '', 'The HMAC key value to verify transactions with', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Demo Gateway ID', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_LOGIN_ID', '', 'DEMO ACCOUNT: The Gateway ID used for the Payeezy E-Commerce Transactions', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Demo Gateway Password', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_PASSWORD', '', 'DEMO ACCOUNT: The Gateway password to authorize payments', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Demo Transaction Key', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_TRANSACTION_KEY', '', 'DEMO ACCOUNT: The Gateway Transaction Key to authorize payments', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Demo HMAC Key', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_MD5_HASH', '', 'DEMO ACCOUNT: The HMAC key value to verify transactions with', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_GGE4_CC_AIM_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_GGE4_CC_AIM_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_GGE4_CC_AIM_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_GGE4_CC_AIM_STATUS', 'MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_MODE', 'MODULE_PAYMENT_GGE4_CC_AIM_LOGIN_ID', 'MODULE_PAYMENT_GGE4_CC_AIM_PASSWORD', 'MODULE_PAYMENT_GGE4_CC_AIM_TRANSACTION_KEY', 'MODULE_PAYMENT_GGE4_CC_AIM_MD5_HASH', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_LOGIN_ID', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_PASSWORD', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_TRANSACTION_KEY', 'MODULE_PAYMENT_GGE4_CC_AIM_DEMO_MD5_HASH', 'MODULE_PAYMENT_GGE4_CC_AIM_ZONE', 'MODULE_PAYMENT_GGE4_CC_AIM_ORDER_STATUS_ID', 'MODULE_PAYMENT_GGE4_CC_AIM_SORT_ORDER');
    }

// format prices without currency formatting
    function format_raw($number, $currency_code = '', $currency_value = '') {
      global $currencies, $currency;

      if (empty($currency_code) || !$this->is_set($currency_code)) {
        $currency_code = $currency;
      }

      if (empty($currency_value) || !is_numeric($currency_value)) {
        $currency_value = $currencies->currencies[$currency_code]['value'];
      }

      return number_format(tep_round($number * $currency_value, $currencies->currencies[$currency_code]['decimal_places']), $currencies->currencies[$currency_code]['decimal_places'], '.', '');
    }
  }
?>
